package automorphology.core;

/**
 * <p>Title: Auto-Morphology</p>
 * <p>Description: A morphological analyzer based on Goldsmith's algorithm</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Haifa University</p>
 * @author Yaniv Alamaru, Ofer Senderovich
 * @version 1.0
 */

/**
 * IIncrementalHeuristic is an interface which represent an incremental
 * heuristic in goldsmith's algorithm. The purpose of the heuristic is
 * to take a morphology and try to improve it by suggesting a new morphology.
 * The new morphology improvement is judeged by comparing the MDL of the
 * two morphologies.
 * <p>Company: Haifa University</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @version 1.0
 */
public interface IIncrementalHeuristic {
      public IMorphology analyze(ICorpus corpus, IMorphology oldMorphology);
}