package automorphology.core;

import java.util.*;

/**
 * <p>Title: Auto-Morphology</p>
 * <p>Description: A morphological analyzer based on Goldsmith's algorithm</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Haifa University</p>
 * @author Yaniv Alamaru, Ofer Senderovich
 * @version 1.0
 */

public class JSet{
      private Vector theSet = new Vector();
      public JSet(JSet set) {
            theSet = new Vector(set.theSet);
      }
      public JSet() {
      }
      public JSet(Set set) {
            Iterator it = set.iterator();
            while(it.hasNext()) {
                  theSet.add(it.next());
            }
      }

      public boolean add(Object obj) {
            int index = 0;
            for (index = 0 ; index < theSet.size() ; index++) {
                  Comparable comp = (Comparable)theSet.elementAt(index);
                  int comp_result = comp.compareTo(obj);
                  if (comp_result == 0)
                        return false;
                  else if (comp_result > 0)
                        break;
            }
            if (index == theSet.size())
                  theSet.add(obj);
            else
                  theSet.add(index,obj);
            return true;
      }

      public void addAll(JSet col) {
            Iterator it = col.iterator();
            while(it.hasNext()) {
                  this.add(it.next());
            }
      }

      public Iterator iterator() {
            return theSet.iterator();
      }
      public int size() {
            return theSet.size();
      }
      public boolean equals2(Object obj) {
            JSet set2 = (JSet)obj;
            JSet set1 = this;
            if (set1.size() != set2.size())
                  return false;
            Iterator it1 = set1.iterator();
            while (it1.hasNext()) {
                  boolean contained = false;
                  Object suffix1 = it1.next();
                  Iterator it2 = set2.iterator();
                  while(it2.hasNext()) {
                        Object suffix2 = it2.next();
                        if (suffix1.equals(suffix2))
                              contained = true;
                  }
                  if (contained == false)
                        return false;
            }
            return true;
      }
      public boolean equals(Object obj) {
            JSet set2 = (JSet)obj;
            JSet set1 = this;
            if (set1.size() != set2.size())
                  return false;
            Iterator it1 = set1.iterator();
            Iterator it2 = set2.iterator();
            while (it1.hasNext()) {
                  Object obj1 = it1.next();
                  Object obj2 = it2.next();
                  if (!(obj1.equals(obj2)))
                        return false;
            }
            return true;
      }
      public void remove(Object obj) {
            Iterator it = theSet.iterator();
            while(it.hasNext()) {
                  if (obj.equals(it.next())) {
                        it.remove();
                        return;
                  }
            }
      }
      public void clear() {
            theSet.clear();
      }
      public boolean contains(Object obj) {
            Iterator it = theSet.iterator();
            while(it.hasNext()) {
                  if (it.next().equals(obj))
                        return true;
            }
            return false;
      }
}