package automorphology.core;

/**
 * <p>Title: Auto-Morphology</p>
 * <p>Description: A morphological analyzer based on Goldsmith's algorithm</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Haifa University</p>
 * @author Yaniv Alamaru, Ofer Senderovich
 * @version 1.0
 */

public class Suffix implements ISuffix {

      private String suffixString;

      public Suffix(String suffixString) {
            this.suffixString = new String(suffixString);
      }

      public double descriptionLength(ICorpus corpus, IMorphology morphology) {
            double suffixLetterLength = Math.log(26)*Math.log(2)*suffixString.length();
            return suffixLetterLength +this.pointerLength(corpus,morphology);
      }

      public double pointerLength(ICorpus corpus, IMorphology morphology) {
            double tmp = morphology.getNumberOfAnalyzedWord(corpus) / (double)/*morphology.getSuffixFrequency(this)*/corpus.getSuffixFrequency(this,morphology);
            return Math.log(tmp) / Math.log(2);
      }

      public String toString() {
            return suffixString;
      }

      public boolean equals(Object suffix) {
            if (suffixString.length() != ((ISuffix)suffix).toString().length())
                  return false;
            return (suffixString.compareTo(((ISuffix)suffix).toString()) == 0);
      }

      public int compareTo(Object o) {
            ISuffix suffix = (ISuffix)o;
            return suffixString.compareTo(suffix.toString());
            /*
            if (suffix.toString().length() > this.suffixString.length())
                  return 1;
            if (suffix.toString().length() < this.suffixString.length())
                  return -1;
            return (-1)*this.suffixString.compareTo(suffix.toString());
            */
      }
}