package automorphology.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * <p>Title: Auto-Morphology</p>
 * <p>Description: A morphological analyzer based on Goldsmith's algorithm</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Haifa University</p>
 * @author Yaniv Alamaru, Ofer Senderovich
 * @version 1.0
 */

/**
 * AutoMorphologyAboutBox is a dialog which show the about details.
 * The about details includes the name of the application and the
 * persons who worte it.
 * @author Yaniv Alamaru, Ofer Senderovich
 * <p>Company: Haifa University</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @version 1.0
 */
public class AutoMorphologyAboutBox extends JDialog implements ActionListener {

      private JPanel panel1 = new JPanel();
      private JPanel panel2 = new JPanel();
      private JPanel insetsPanel1 = new JPanel();
      private JPanel insetsPanel2 = new JPanel();
      private JPanel insetsPanel3 = new JPanel();
      private JButton button1 = new JButton();
      private JLabel imageLabel = new JLabel();
      private JLabel label1 = new JLabel();
      private JLabel label2 = new JLabel();
      private JLabel label3 = new JLabel();
      private JLabel label4 = new JLabel();
      private BorderLayout borderLayout1 = new BorderLayout();
      private BorderLayout borderLayout2 = new BorderLayout();
      private FlowLayout flowLayout1 = new FlowLayout();
      private GridLayout gridLayout1 = new GridLayout();
      private String product = "Auto-Morphology";
      private String version = "1.0";
      private String copyright = "Copyright (c) 2002";
      private String comments = "A morphological analyzer based on Goldsmith's algorithm";
      public AutoMorphologyAboutBox(Frame parent) {
            super(parent);
            enableEvents(AWTEvent.WINDOW_EVENT_MASK);
            try {
                  jbInit();
            }
            catch(Exception e) {
                  e.printStackTrace();
            }
      }
      //Component initialization
      private void jbInit() throws Exception  {
            //imageLabel.setIcon(new ImageIcon(Frame2_AboutBox.class.getResource("[Your Image]")));
            this.setTitle("About");
            panel1.setLayout(borderLayout1);
            panel2.setLayout(borderLayout2);
            insetsPanel1.setLayout(flowLayout1);
            insetsPanel2.setLayout(flowLayout1);
            insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
            gridLayout1.setRows(4);
            gridLayout1.setColumns(1);
            label1.setText(product);
            label2.setToolTipText("");
            label2.setText("Version: 1.0");
            label3.setText(copyright);
            label4.setDoubleBuffered(true);
            label4.setPreferredSize(new Dimension(316, 50));
            label4.setToolTipText("");
            label4.setDisplayedMnemonic('0');
            label4.setText("A morphological analyzer based on Goldsmith\'s algorithm.");
            insetsPanel3.setLayout(gridLayout1);
            insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
            button1.setText("Ok");
            button1.addActionListener(this);
            insetsPanel2.add(imageLabel, null);
            panel2.add(insetsPanel3, BorderLayout.CENTER);
            panel2.add(insetsPanel2, BorderLayout.WEST);
            this.getContentPane().add(panel1, null);
            insetsPanel3.add(label1, null);
            insetsPanel3.add(label2, null);
            insetsPanel3.add(label3, null);
            insetsPanel3.add(label4, null);
            insetsPanel1.add(button1, null);
            panel1.add(insetsPanel1, BorderLayout.SOUTH);
            panel1.add(panel2, BorderLayout.NORTH);
            setResizable(true);
      }
      //Overridden so we can exit when window is closed
      protected void processWindowEvent(WindowEvent e) {
            if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                  cancel();
            }
            super.processWindowEvent(e);
      }
      //Close the dialog
      void cancel() {
            dispose();
      }
      //Close the dialog on a button event
      public void actionPerformed(ActionEvent e) {
            if (e.getSource() == button1) {
                  cancel();
            }
      }
}